package ru.amse.vorobiev.lce.circuit;

import java.util.List;
import java.util.Set;

import ru.amse.vorobiev.lce.elements.*;
import ru.amse.vorobiev.lce.elements.impl.InGate;
import ru.amse.vorobiev.lce.elements.impl.OutGate;
import ru.amse.vorobiev.lce.interpreter.IInterpreter;
import ru.amse.vorobiev.lce.ui.IChangeListener;

public interface ICircuit {
	public void addGate(IGate gate);
	public void removeGate(IGate gate);
	public void addSubcircuit(InGate gate);
	public Set<InGate> getInGates();
	public Set<OutGate> getOutGates();
	public Set<IGate> getAllGates();
	public int size();
	public void fireCircuitChanged();
	public void addChangeListener(IChangeListener listener);
	public List<IChangeListener> getChangeListeners();
	public IInterpreter getInterpreter();
}
