package ru.amse.vorobiev.lce.elements;

import ru.amse.vorobiev.lce.circuit.ICircuit;
import ru.amse.vorobiev.lce.elements.impl.GateType;

public interface IGate extends IElement {
	public ICircuit getCircuit();
	public void setCircuit(ICircuit circuit);
	public IPlug getInput(int index);
	public IPlug getOutput(int index);
	public int getInputIndex(IPlug plug);
	public int getOutputIndex(IPlug plug);
	public int getInputCount();
	public int getOutputCount();
	public GateType getType();
	public void fireGateChanged();
	public IPlug addInput();
	public IPlug addOutput();
	public void deleteInput(int i);
	public void deleteOutput(int i);
}
