package ru.amse.vorobiev.lce.elements.impl;

import ru.amse.vorobiev.lce.elements.IGate;
import ru.amse.vorobiev.lce.elements.IPlug;
import ru.amse.vorobiev.lce.elements.IWire;

public class Plug implements IPlug {
	private boolean mySignal;
	private final IGate myGate;
	private IWire myWire;
	private boolean hasSignal;
	private PlugType myType;
	
	public Plug(IGate gate, PlugType type) {
		myGate = gate;
		hasSignal = false;
		myType = type;
	}
	
	public void setSignal(boolean signal) {
		mySignal = signal;
		hasSignal = true;
	}
	
	public boolean getSignal() {
		return mySignal;
	}
	
	public void setNoSignal() {
		hasSignal = false;
	}
	
	public boolean hasSignal() {
		return hasSignal;
	}
	
	public IGate getGate() {
		return myGate;
	}
	
	public IWire getWire() {
		return myWire;
	}
	
	public void setWire(IWire wire) {
		myWire = wire;
		if (wire != null) {
			switch (myType) {
				case INPUT: {
					wire.setTo(this);
					break;
				}
				case OUTPUT: {
					wire.setFrom(this);
					break;
				}
			}
		}
		myGate.fireGateChanged();
	}

	public PlugType getType() {
		return myType;
	}
}
