package ru.amse.vorobiev.lce.interpreter;

import java.util.Map;
import java.util.Set;

import ru.amse.vorobiev.lce.circuit.ICircuit;
import ru.amse.vorobiev.lce.elements.IPlug;
import ru.amse.vorobiev.lce.elements.impl.InGate;
import ru.amse.vorobiev.lce.elements.impl.OutGate;

public interface IInterpreter {
	public void setUp(ICircuit circuit);
	public void reset();
	public void step();
	public void interprete();
	public Set<InGate> getInGates();
	public Set<OutGate> getOutGates();
	public void setInputs(InGate in, boolean[] inputs);
	public Map<IPlug, Boolean> getVisitedPlugs();
	public boolean allInGatesAreReady();
}
