package ru.amse.vorobiev.lce.ui.tools.impl;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;

import ru.amse.vorobiev.lce.ui.JEditor;
import ru.amse.vorobiev.lce.ui.tools.ITool;
import ru.amse.vorobiev.lce.view.IGateView;
import ru.amse.vorobiev.lce.view.impl.CircuitView;

public class AddingInputOutputTool implements ITool {
	private JEditor myEditor;
	private IGateView mySelectedGate;
	private int myStatus;
	
	public AddingInputOutputTool(JEditor editor) {
		myEditor = editor;
	}

	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		if (mySelectedGate != null) {
			g2.setColor(Color.GRAY);
			switch (myStatus) {
				case CircuitView.ABLE_TO_ADD_INPUT_PLUG:
					g2.fillRect(mySelectedGate.getUpperLeftCorner().x, 
							mySelectedGate.getUpperLeftCorner().y + mySelectedGate.getHeight() - JEditor.PLUG_CONTROL_LENGTH, 
							JEditor.PLUG_CONTROL_LENGTH, JEditor.PLUG_CONTROL_LENGTH);
					break;
				case CircuitView.ABLE_TO_ADD_OUTPUT_PLUG:
					g2.fillRect(mySelectedGate.getUpperLeftCorner().x + mySelectedGate.getWidth() - JEditor.PLUG_CONTROL_LENGTH, 
							mySelectedGate.getUpperLeftCorner().y + mySelectedGate.getHeight() - JEditor.PLUG_CONTROL_LENGTH, 
							JEditor.PLUG_CONTROL_LENGTH, JEditor.PLUG_CONTROL_LENGTH);
					break;
			}
		}
	}

	public void mouseClicked(MouseEvent e) {
		switch (myStatus) {
		case CircuitView.ABLE_TO_ADD_INPUT_PLUG:
			mySelectedGate.addInput();
			break;
		case CircuitView.ABLE_TO_ADD_OUTPUT_PLUG:
			mySelectedGate.addOutput();
			break;
		}
		myEditor.repaint();
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseDragged(MouseEvent e) {
	}
	

	public void mouseMoved(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		mySelectedGate = myEditor.getView().getGateForLocation(x, y);
		if (mySelectedGate != null) {
			myStatus = myEditor.getView().ableToAddPlugInLocation(x, y, mySelectedGate);
		} else {
			myStatus = CircuitView.UNABLE_TO_ADD_PLUG;
		}
		myEditor.repaint();
	}

}
