package ru.amse.vorobiev.lce.ui.tools.impl;

import java.awt.Point;

import ru.amse.vorobiev.lce.circuit.ICircuit;
import ru.amse.vorobiev.lce.elements.IGate;
import ru.amse.vorobiev.lce.elements.impl.AndGate;
import ru.amse.vorobiev.lce.ui.JEditor;
import ru.amse.vorobiev.lce.view.ICircuitView;
import ru.amse.vorobiev.lce.view.IGateView;
import ru.amse.vorobiev.lce.view.impl.GateView;

public class AndGateCreationTool extends AbstractGateCreationTool{
	
	public AndGateCreationTool(JEditor editor) {
		super(editor);
	}

	@Override
	protected void createNewGate(int x, int y, ICircuitView view) {
		ICircuit circuit = view.getCircuit();
		IGate gate = new AndGate(circuit);
		circuit.addGate(gate);
		IGateView gateView = new GateView(new Point(x, y), gate, view);
		view.addViewByElement(gate, gateView);
	}
}
