package ru.amse.vorobiev.lce.ui.tools.impl;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseEvent;

import ru.amse.vorobiev.lce.ui.JEditor;
import ru.amse.vorobiev.lce.ui.tools.ITool;
import ru.amse.vorobiev.lce.view.IGateView;

public class GateDraggingTool implements ITool {
	private IGateView mySelectedGate;
	private Point myMousePosition;
	private JEditor myEditor;
	
	public GateDraggingTool(JEditor editor) {
		myEditor = editor;
		myMousePosition = new Point(0,0);
	}

	public void paint(Graphics g) {
	}

	public void mouseClicked(MouseEvent e) {	
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
		if (myEditor.getView() != null) {
			int x = e.getX();
			int y = e.getY();
			mySelectedGate = myEditor.getView().getGateForLocation(x, y);
			if (myEditor.getSelectedGates().contains(mySelectedGate)) {
				myMousePosition = new Point(x, y);
			}
		}
	}

	public void mouseReleased(MouseEvent e) {
		mySelectedGate = null;
	}

	public void mouseDragged(MouseEvent e) {
		if (myEditor.getSelectedGates().contains(mySelectedGate)) {
			int x = e.getX();
			int y = e.getY();
			int dx = x - myMousePosition.x;
			int dy = y - myMousePosition.y;
			for (IGateView gateView : myEditor.getSelectedGates()) {
				Point upperLeftCorner = gateView.getUpperLeftCorner();
				upperLeftCorner.x += dx;
				upperLeftCorner.y += dy;
				gateView.setUpperLeftCorner(upperLeftCorner);
			}
			myEditor.repaint();
			myMousePosition.x = x;
			myMousePosition.y = y;
			myEditor.ensureSize();
			myEditor.fireEditorChanged();
			myEditor.repaint();
		}
	}

	public void mouseMoved(MouseEvent e) {
		myMousePosition.x = e.getX();
		myMousePosition.y = e.getY();
	}

}
