package ru.amse.vorobiev.lce.validator;

import ru.amse.vorobiev.lce.elements.IElement;
import ru.amse.vorobiev.lce.elements.IPlug;

public class PlugError implements IError {
	private String myMessage;
	private boolean isWarning;
	private IElement myElement;
	
	public PlugError(IPlug plug, String message) {
		myMessage = message;
		isWarning = true;
		myElement = plug;
	}
	
	public IElement getElement() {
		return myElement;
	}
	
	public PlugError(IPlug plug) {
		this(plug, "");
	}
	
	public void setMessage(String message) {
		myMessage = message;
	}
	
	public String getMessage() {
		return myMessage;
	}

	public boolean isWarning() {
		return isWarning;
	}

}
