package ru.amse.vorobiev.lce.view;

import java.awt.Graphics;

import ru.amse.vorobiev.lce.circuit.ICircuit;
import ru.amse.vorobiev.lce.elements.IElement;

public interface ICircuitView {
	public void paint(Graphics g);
	public ICircuit getCircuit();
	public IGateView getGateForLocation(int x, int y);
	public IPlugView getPlugForLocation(int x, int y);
	public IElementView addViewByElement(IElement element, IElementView elementView);
	public IElementView getViewByElement(IElement element);
	public IElementView removeViewByElement(IElement element);
	public int ableToAddPlugInLocation(int x, int y, IGateView gateView);
	public int ableToDeletePlugInLocation(int x, int y, IGateView gateView);
	public int getInputPlugToDelete(int x, int y, IGateView gateView);
	public int getOutputPlugToDelete(int x, int y, IGateView gateView);
}
